/*
 * port.c
 *
 *  Created on: Mar 4, 2017
 *      Author: Ting
 */

#include "port.h"

/*!
 * \brief Habilita o clock de um m&oacute;dulo PORT
 * \param[in] p porta
 */
void initPort (porta p)
{
	switch (p) {
	case A:
		SIM_SCGC5 |= SIM_SCGC5_PORTA_MASK;
		break;
	case B:
		SIM_SCGC5 |= xxxx;
		break;
	case C:
		SIM_SCGC5 |= xxxx;
		break;
	case D:
		SIM_SCGC5 |= xxxx;
		break;
	case E:
		SIM_SCGC5 |= xxxx;
	}
}

/*!
 * \brief seta a fun&ccedil;&atilde;o do pino
 * \param[in] reg endere&ccedil;o do registrador do pino n da PORTA x
 * \param[in] mux fun&ccedil;&atilde;o do pino
 */
void setaMux(unsigned int volatile *reg, uint8_t mux) {
	*reg &= xxxx;      ///< limpa o campo MUX (0b000)
	
	*reg |= (PORT_PCR_ISF_MASK |       ///< ISF=PORTB_PCR18[14]: w1c (limpa a pendncia)
			 PORT_PCR_MUX(mux) );      ///< seta fun&ccedil;&atilde;o 
}

/*!
 * \brief reseta o campo MUX do registrador do pino em 000
 * \param[in] reg endere&ccedil;o do registrador do pino n da PORTA x
 * \param[in] mux fun&ccedil;&atilde;o do pino
 */
void resetaMux(unsigned int volatile *reg) {
	*reg |= PORT_PCR_ISF_MASK;        ///< ISF=PORTB_PCR18[14]: w1c (limpa a pendncia)
	*reg &=	~PORT_PCR_MUX(0x7);        ///< reseta MUX  
}
