/*
 * tpm.h
 *
 *  Created on: Mar 3, 2017
 *      Author: Ting
 */

#ifndef TPM_H_
#define TPM_H_

#include "derivative.h"
#include "util.h"

#define eTPM0_SC	(unsigned int volatile *)0x40038000	
#define eTPM0_CNT	(unsigned int volatile *)0x40038004
#define eTPM0_MOD	(unsigned int volatile *)0x40038008
#define eTPM0_STATUS	(unsigned int volatile *)0x40038050
#define eTPM0_CONF		(unsigned int volatile *)0x40038084

#define eTPM1_SC	(unsigned int volatile *)0x40039000	
#define eTPM1_CNT	(unsigned int volatile *)0x40039004
#define eTPM1_MOD	(unsigned int volatile *)0x40039008
#define eTPM1_STATUS	(unsigned int volatile *)0x40039050
#define eTPM1_CONF		(unsigned int volatile *)0x40039084

#define eTPM2_SC	(unsigned int volatile *)0x4003a000	
#define eTPM2_CNT	(unsigned int volatile *)0x4003a004
#define eTPM2_MOD	(unsigned int volatile *)0x4003a008
#define eTPM2_STATUS	(unsigned int volatile *)0x4003a050
#define eTPM2_CONF		(unsigned int volatile *)0x4003a084

#define eTPM0_C0SC	(unsigned int volatile *)0x4003800c	
#define eTPM0_C0V	(unsigned int volatile *)0x40038010	
#define eTPM0_C1SC	(unsigned int volatile *)0x40038014	
#define eTPM0_C1V	(unsigned int volatile *)0x40038018	
#define eTPM0_C2SC	(unsigned int volatile *)0x4003801c	
#define eTPM0_C2V	(unsigned int volatile *)0x40038020	
#define eTPM0_C3SC	(unsigned int volatile *)0x40038024	
#define eTPM0_C3V	(unsigned int volatile *)0x40038028	
#define eTPM0_C4SC	(unsigned int volatile *)0x4003802c	
#define eTPM0_C4V	(unsigned int volatile *)0x40038030	
#define eTPM0_C5SC	(unsigned int volatile *)0x40038034	
#define eTPM0_C5V	(unsigned int volatile *)0x40038038	

#define eTPM1_C0SC	(unsigned int volatile *)0x4003900c	
#define eTPM1_C0V	(unsigned int volatile *)0x40039010	
#define eTPM1_C1SC	(unsigned int volatile *)0x40039014	
#define eTPM1_C1V	(unsigned int volatile *)0x40039018	

#define eTPM2_C0SC	(unsigned int volatile *)0x4003a00c	
#define eTPM2_C0V	(unsigned int volatile *)0x4003a010	
#define eTPM2_C1SC	(unsigned int volatile *)0x4003a014	
#define eTPM2_C1V	(unsigned int volatile *)0x4003a018	

void initTPM(uint8_t modulo, uint8_t pre, uint16_t counter, uint8_t cpwms);

uint8_t initTPM0Cn(uint8_t canal, uint8_t c_modo, unsigned short valor);
uint8_t initTPM1Cn(uint8_t canal, uint8_t c_modo, unsigned short valor);
uint8_t initTPM2Cn(uint8_t canal, uint8_t c_modo, unsigned short valor);

uint8_t reconfigModoTPM0Cn(uint8_t canal, uint8_t c_modo);
uint8_t reconfigModoTPM1Cn(uint8_t canal, uint8_t c_modo);
uint8_t reconfigModoTPM2Cn(uint8_t canal, uint8_t c_modo);

uint8_t reconfigValorTPM0Cn(uint8_t canal, unsigned short valor);
uint8_t reconfigValorTPM1Cn(uint8_t canal, unsigned short valor);
uint8_t reconfigValorTPM2Cn(uint8_t canal, unsigned short valor);

uint8_t enableTPMInterrup(uint8_t modulo);
uint8_t disableTPMInterrup(uint8_t modulo);

uint8_t enableTPM0CnInterrup(uint8_t canal);
uint8_t disableTPM0CnInterrup(uint8_t canal);
uint8_t enableTPM1CnInterrup(uint8_t canal);
uint8_t disableTPM1CnInterrup(uint8_t canal);
uint8_t enableTPM2CnInterrup(uint8_t canal);
uint8_t disableTPM2CnInterrup(uint8_t canal);

#endif /* TPM_H_ */
